###
### Eventscripts Updater
### ~~~~~~~~~~~~~~~~~~~~
### Version: 1.1
### Author : Ojii
###
#
# Changes
# -------
# 1.1:
#  -removed unneccessary functions in updater_noes.py
#  -removed unneccessary imports in updater_noes.py
#  -replaced 'quit' command with 'exit'
#  -added zipfile closing to updater_noes.py
#
#


import path
import zipfile
import sys
import os
import time

class SmallEasyZip(object):
    def __init__(self,dst,flag='w'):
        dst = path.path(dst)
        self.mkdirs(dst)
        self.z = zipfile.ZipFile(dst,flag)
        self.dirs = []
        
    def extract(self,dst='./'): # extract the files of the archive
        dst = path.path(dst)
        for f in self.files():
            c = dst.joinpath(f)
            self.extractFile(f,c)
    
    def extractFile(self,src,dst='./'): # extract a single file
        dst = dst.replace('\\','/')
        if dst[-1] == '/':
            dst = path.path(dst).joinpath(path.path(src).basename())
        else:
            dst = path.path(dst)
        self.mkdirs(dst)
        dst.write_bytes(self.__read(src))

    def mkdirs(self,dst):
        old = 0
        new = dst.dirname()
        dirs = []
        while old != new:
            dirs.append(new)
            old = new
            new = new.dirname()
        dirs.reverse()
        for d in dirs:
            if not d.isdir():
                d.mkdir()
    
    def files(self): # return a list of files
        return filter(lambda x: x[-1] != '/',self.z.namelist())
    
    def close(self): # close the file
        self.z.close()
    
    def __read(self,src):
        return self.z.read(src)

args = sys.argv[1:]
gamedir = args.pop(0)
server_command = ' '.join(args)

gamedir = path.path(gamedir)
temp = gamedir.joinpath('addons/eventscripts/updater/temp.zip')
vdffile = gamedir.joinpath('addons/mattie_eventscripts.vdf')

vdftemplate = '''"Plugin"
{
        "file"  "../$$$game$$$/addons/mattie_eventscripts"
}'''

def vdf():
    game = gamedir.namebase
    if not game:
        game = gamedir.dirname().namebase
    vdffile.write_text(vdftemplate.replace('$$$game$$$',game))

def updater():
    z = EasyZip(temp,'r')
    print 'Extracting files...'
    z.extract(gamedir)
    print 'Extracting files... Done'
    print 'Verifying VDF... '
    vdf()
    print 'Cleaning up...'
    z.close()
    temp.remove()
    os.system(server_command)

updater()
print 'Sleeping 10 seconds before restart...'
time.sleep(10)
